SystemOrganization addCategory: #'Moe-Model'!
SystemOrganization addCategory: #'Moe-Magritte'!
SystemOrganization addCategory: #'Moe-Seaside'!
SystemOrganization addCategory: #'Moe-Tests'!
SystemOrganization addCategory: #'Moe-Tests-Magritte'!

!String methodsFor: '*moe' stamp: 'jmck 6/9/2009 10:31'!
asIntegerArray
	^(self allButFirst allButLast subStrings: #($,)) 
			collect: [ :string | Number readFrom: (ReadStream on: string) ]! !

MACheckedMementoTest subclass: #MOMementoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests-Magritte'!

!MOMementoTest methodsFor: 'as yet unclassified' stamp: 'jmck 2/7/2010 01:35'!
actualClass 
	^MOMemento ! !

MACheckedMemento subclass: #MOMemento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOMemento methodsFor: 'actions' stamp: 'jmck 2/10/2010 22:28'!
push: aDictionary
	"handle removed children"
	| originalChildren |
	aDictionary keysAndValuesDo: [ :key :value |
		key isEmbeddedCollection 
			ifTrue: [originalChildren := self model readUsing: key.
				value = originalChildren 
					ifFalse: [originalChildren do: [ :child |
							(value indexOf: child) = 0 ifTrue: [ child delete ]]]]].
	super push: aDictionary.! !

!MOMemento methodsFor: 'actions' stamp: 'jmck 2/10/2010 22:46'!
reset
	"delete added children"
	| originalChildren |
	cache isNil ifFalse: [
		cache keysAndValuesDo: [ :key :value |
			key isEmbeddedCollection 
				ifTrue: [originalChildren := self model readUsing: key.
					value = originalChildren 
						ifFalse: [value do: [ :child |
							(originalChildren indexOf: child) = 0
								ifTrue: [ child delete ]]]]]].
	super reset.! !

MAPriorityContainer subclass: #MOContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOContainer commentStamp: 'jmck 6/12/2009 14:57' prior: 0!
I exist to point to an MOEmbeddedContainerComponent which saves the model to the DB after commiting the memento to the model.!

!MOContainer methodsFor: 'accessing' stamp: 'jmck 2/9/2010 19:52'!
componentClass
	^MOContainerComponent! !

!MOContainer methodsFor: 'accessing' stamp: 'jmck 2/20/2010 01:10'!
componentRenderer
	^MOTableRenderer! !

!Collection methodsFor: '*moe' stamp: 'jmck 9/19/2009 10:15'!
asIntegerArrayString
	"collection elements must respond to id, i.e. MAMappedObject"
	^String streamContents: [ :s | 
		s nextPut: ${.
		self do: [ :each | s nextPutAll: each id asString ] separatedBy: [ s nextPut: $, ].
		"nextPutAll: (self collect: [ :each | each id ]) asCommaString;"
		s nextPut: $} ]! !

MAToOneRelationDescription subclass: #MOEmbeddedObjectDescription
	instanceVariableNames: 'objectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedObjectDescription commentStamp: 'jmck 6/12/2009 14:57' prior: 0!
I am a convenience description. I return true for isEmbedded ao you don;t have of to send beEmbeddedCollection (but you still have to type EmbeddedCollection!!). I also have a useless objectClass method that is supposed to be a convenience but only serves to confuse issues further lol

I do implement componentClass which returns a nifty lookup component.

The author is still deciding whether or not to toss me like he has the rest of his bloated framework!

!MOEmbeddedObjectDescription class methodsFor: 'as yet unclassified' stamp: 'jmck 2/15/2010 18:50'!
defaultComponentClass
	^MOSelectComponent! !

!MOEmbeddedObjectDescription methodsFor: 'visiting' stamp: 'jmck 10/12/2009 09:13'!
acceptMagritte: aVisitor
	aVisitor visitElementDescription: self! !

!MOEmbeddedObjectDescription methodsFor: 'testing' stamp: 'jmck 6/12/2009 14:51'!
isEmbedded
	^true! !

!MOEmbeddedObjectDescription methodsFor: 'accessing' stamp: 'jmck 6/11/2009 23:09'!
objectClass
	"Answer the value of objectClass"

	^ objectClass ifNil: [ self classes first ]! !

!MOEmbeddedObjectDescription methodsFor: 'accessing' stamp: 'jmck 6/13/2009 13:12'!
objectClass: aClass
	"Set the value of objectClass"

	objectClass := aClass.
		classes isNil
			ifTrue: [classes := Array with: aClass]
			ifFalse: [ classes := (Array with: aClass) addAll: classes ].! !

!MOEmbeddedObjectDescription methodsFor: 'accessing-properties' stamp: 'jmck 7/26/2009 20:59'!
sqlColumnType
	^'integer'! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
beEmbedded
	self propertyAt: #embedded put: true! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
beEmbeddedCollection
	self propertyAt: #embeddedCollection put: true! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
isEmbedded
	^self propertyAt: #embedded ifAbsent: [ false ]! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
isEmbeddedCollection
	^self propertyAt: #embeddedCollection ifAbsent: [ false ]! !

TestCase subclass: #MOEmbeddedObjectTest
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 7/14/2009 10:21'!
addEmbeddedObjects
	object embedded add: (MOMockSubObject new
				privateId: 1; 
				field1: 1; 
				field2: 2; 
				field3: 3; 
				yourself).
	object embedded add: (MOMockSubObject new 
				privateId: 2; 
				field1: 2; 
				field2: 3; 
				field3: 4; 
				yourself).
	object embedded add: (MOMockSubObject new 
				privateId: 3; 
				field1: 3; 
				field2: 4; 
				field3: 5; 
				yourself).
			! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 7/16/2009 13:09'!
setUp
	object := MOMockObject new. 
! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 12/18/2009 20:59'!
testAttributeValueFor
	self assert: [ (object attributeValueFor: 'embedded') = '{}'].
	self addEmbeddedObjects.
	self assert: [ (object attributeValueFor: 'field1') = '1'].
	self assert: [ (object attributeValueFor: 'field2') = 100 ].
	self assert: [ (object attributeValueFor: 'field3') = '2'].
	self assert: [ (object attributeValueFor: 'embedded') = '{1,2,3}'].
	self assert: [ (object attributeValueFor: 'scalar') isNil ].
! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 12/18/2009 20:59'!
testHasEmbeddedChildren
	self setUp.
	self deny: [ object hasEmbeddedChildren ].
	self addEmbeddedObjects.
	self assert: [ object hasEmbeddedChildren].! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:57'!
testMappedDescription
	self assert: [ object mappedDescription children size = 5 ].
! !

MATableRenderer subclass: #MOTableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOTableRenderer methodsFor: 'private' stamp: 'jmck 2/8/2010 22:09'!
classFor: aDescription
	| classes |
	(aDescription isContainer and: [component hasChanged])
		ifTrue: [ ^'modified', ((classes := super classFor: aDescription ) isNil ifTrue: [''] ifFalse: [classes])].
	^super classFor: aDescription! !

MAExternalEditorComponent subclass: #MOSelectComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOSelectComponent commentStamp: 'jmck 6/12/2009 08:41' prior: 0!
An embeddedobject lookup component
Good for one-to-one object lookup, renders the create button to add a new lookup object to the lookup list.!

!MOSelectComponent methodsFor: 'rendering' stamp: 'jmck 6/28/2009 09:17'!
renderEditorOn: html
	self renderSelectListOn: html.
	super renderSelectButtonOn: html.! !

!MOSelectComponent methodsFor: 'rendering' stamp: 'JohnMcKeon 3/11/2010 18:30'!
renderSelectListOn: html
	| instances | 
	(instances := self selected list) isEmpty
		ifFalse: [ 
			html select
				list: ((Array with: nil) , instances);
				selected: self value;
				callback: self selectCallback ]
		ifTrue: [ html text: ('No ' , self selected asString allButFirst: 2 , 's found') ]
! !

!MOSelectComponent methodsFor: 'rendering' stamp: 'jmck 6/11/2009 23:22'!
renderViewerOn: html
	self renderEditorOn: html! !

!MOSelectComponent methodsFor: 'rendering' stamp: 'jmck 2/15/2010 16:09'!
selectCallback
	^[ :item | item ifNotNil: [ self value: item ] ]! !

MAToManyRelationDescription subclass: #MOEmbeddedCollectionDescription
	instanceVariableNames: 'objectClass collectionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedCollectionDescription commentStamp: 'jmck 6/12/2009 14:59' prior: 0!
I am a convenience description. I return true for isEmbeddedCollection so you don't have of to send beEmbeddedCollection (but you still have to type EmbeddedCollection!!). I also have a useless objectClass method that is supposed to be a convenience but only serves to confuse issues further lol

The author is still deciding whether or not to toss me like he has the rest of his bloated framework!

!MOEmbeddedCollectionDescription class methodsFor: 'as yet unclassified' stamp: 'jmck 6/12/2009 15:09'!
defaultCollectionClass
	^OrderedCollection! !

!MOEmbeddedCollectionDescription methodsFor: 'testing' stamp: 'jmck 6/12/2009 14:52'!
isEmbeddedCollection
	^true! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing' stamp: 'jmck 7/4/2009 12:30'!
objectClass
	^objectClass ifNil: [^self classes first ]! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing' stamp: 'jmck 6/13/2009 13:39'!
objectClass: aClass
	"Set the value of objectClass"

	objectClass := aClass.
	classes isNil 
		ifTrue: [ classes := (Array with: aClass) ]
		ifFalse: [ classes := (Array with: aClass) addAll: classes ]! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing-properties' stamp: 'jmck 7/26/2009 21:00'!
sqlColumnType
	^'integer[]'! !

MAMappedObject subclass: #MOObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Model'!

!MOObject commentStamp: 'jmck 6/12/2009 11:10' prior: 0!
Moe is a simple object persistency strategy using Magritte and Roe - Moe!!
The main architectural feature is that Moe make the database "mirror" the Smalltalk objects rather than force the objects to adhere to all sorts of strangulations like pesky foreign key definitions and the like. 

The base class, MOEmbeddedObject,  is a descendant of MAMappedObject. All persisting objects must descend from MOEmbeddedObject and override loadEmbeddedObjectFor: aDescription withId: anId. MODatalistObject and MODatabaseObject are two classes from which you can descend "out of the box". Datalists keep a list of ALL of its instances in a class variable. The latter loads only the objects as they are referenced. 


Describe an embedded object 'Customer' like so:
descriptionCustomer
	^MOEmbeddedObjectDescription new
		objectClass: Customer; 
		embeddedAccessor: #customer;
		label: 'Customer';
		sqlColumnName: 'customer';
		sqlColumnType: 'integer';
		priority: 10;
		yourself
		
When a Moe described objects will have their ID stored in the database in the column where the object should be, and on retrieval from the DB it will be restored with the Smalltalk object. Collections will have an array of integers stored in the DB from which the collection will be restored upon retrieval.

This is pretty lightweight (I think), and is meant only as a means of persistency (read: data backup and restore)
!

MOObject subclass: #MODatabaseObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Model'!

!MODatabaseObject commentStamp: 'jmck 6/11/2009 18:00' prior: 0!
I am like the Datalist object but I don't load all of the insances of me from the database.!

!MODatabaseObject methodsFor: 'persistence' stamp: 'jmck 9/24/2009 07:22'!
loadEmbeddedObjectFor: aDescription withId: anId

	 ^ aDescription classes first loadId: anId! !

MOObject subclass: #MODatalistObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Model'!

MODatalistObject class
	instanceVariableNames: 'List ListMutex'!

!MODatalistObject commentStamp: 'jmck 6/11/2009 17:58' prior: 0!
I am really an example class of one way to maintain the database of objects in the image. I load all the instances of me in a List variable!

MODatalistObject class
	instanceVariableNames: 'List ListMutex'!

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 7/5/2009 14:32'!
initialize
	Smalltalk addToStartUpList: self; addToShutDownList: self! !

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 2/15/2010 12:44'!
list
	self listMutex critical: [
		List ifNil: [ 
			[ 
				List := self loadAll asOrderedCollection.
			] 
			on: Error do: [ :ex | Transcript cr; show: ex; cr. List := nil ] ] ].
	^List! !

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 2/15/2010 12:28'!
listMutex
	^ListMutex ifNil: [ ListMutex := Mutex new ].! !

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 6/13/2009 12:49'!
reset
	List := nil! !

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 7/5/2009 14:24'!
shutDown
	self allSubclasses do: [ :each | each reset ]! !

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 7/5/2009 14:25'!
startUp
	self shutDown.
	self allSubclasses do: [ :each | each list ]! !

!MODatalistObject methodsFor: 'persistence' stamp: 'jmck 1/16/2010 00:06'!
delete
	super delete.
	self list remove: self! !

!MODatalistObject methodsFor: 'private-sql' stamp: 'jmck 6/9/2009 19:46'!
insert
	super insert.
	self list add: self.! !

!MODatalistObject methodsFor: 'persistence' stamp: 'jmck 6/9/2009 19:36'!
list
	^self class list! !

!MODatalistObject methodsFor: 'persistence' stamp: 'jmck 7/3/2009 10:37'!
loadEmbeddedObjectFor: aDescription withId: anId
	^ aDescription objectClass list detect: [ :each | each id = anId ] ifNone: [ nil ]! !

MOObject subclass: #MOMockObject
	instanceVariableNames: 'field1 field2 field3 embedded scalar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:24'!
description1
	^MAStringDescription new
		accessor: #field1;
		label: 'field1';
		sqlColumnName: 'field1';
		sqlColumnType: 'text';
		priority: 10;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/11/2010 21:19'!
description2
	^ MOEmbeddedObjectDescription new
		accessor: #field2;
		label: 'field2';
		sqlColumnName: 'field2';
		sqlColumnType: 'integer';
		priority: 11;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:44'!
description3
	^MAStringDescription new
		accessor: #field3;
		label: 'field3';
		sqlColumnName: 'field3';
		sqlColumnType: 'text';
		priority: 12;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/11/2010 21:18'!
descriptionEmbedded
	^ MOEmbeddedCollectionDescription new
		accessor: #embedded;
		label: 'embedded';
		sqlColumnName: 'embedded';
		sqlColumnType: 'integer[]';
		priority: 11;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:28'!
descriptionScalar
	^MAStringDescription new
		accessor: #scalar;
		label: 'scalar';
		priority: 14;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:45'!
tableName
	^'test'! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:55'!
testMappedDescription
	self assert: [ self mappedDescription size = 5 ].
! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
embedded
	"Answer the value of embedded"

	^ embedded! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
embedded: anObject
	"Set the value of embedded"

	embedded := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field1
	"Answer the value of field1"

	^ field1! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field1: anObject
	"Set the value of field1"

	field1 := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field2
	"Answer the value of field2"

	^ field2! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field2: anObject
	"Set the value of field2"

	field2 := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field3
	"Answer the value of field3"

	^ field3! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field3: anObject
	"Set the value of field3"

	field3 := anObject! !

!MOMockObject methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 22:06'!
initialize
	field1 := '1'.
	field2 := MOMockSubObject new privateId: 100.
	field3 := '2'.
	embedded := OrderedCollection new.
! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:28'!
scalar
	"Answer the value of scalar"

	^ scalar! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:28'!
scalar: anObject
	"Set the value of scalar"

	scalar := anObject! !

MOObject subclass: #MOMockSubObject
	instanceVariableNames: 'field1 field2 field3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field1
	"Answer the value of field1"

	^ field1! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field1: anObject
	"Set the value of field1"

	field1 := anObject! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field2
	"Answer the value of field2"

	^ field2! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field2: anObject
	"Set the value of field2"

	field2 := anObject! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field3
	"Answer the value of field3"

	^ field3! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field3: anObject
	"Set the value of field3"

	field3 := anObject! !

!MOObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/9/2010 19:58'!
descriptionContainer
	^ MOContainer new! !

!MOObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/15/2010 12:37'!
load: aRelation
	| coll | 
	coll := (super load: aRelation) asOrderedCollection.
	Transcript show: coll size asString; cr.
	coll do: [ :each | each loadEmbedded ].
	^coll
	! !

!MOObject methodsFor: 'persistence' stamp: 'jmck 6/18/2009 21:08'!
attributeValueFor: aColumnName
	| desc value |
	desc := self description detect: [ :each | each sqlColumnName = aColumnName ] ifNone: [ ^nil ].
	((value := self readUsing: desc) isNil or: [
		(desc isEmbedded or: [ desc isEmbeddedCollection ]) not ])
		ifTrue: [ ^value ].
	^desc isEmbedded 
		ifTrue: [ value id ]
		ifFalse: [ value asIntegerArrayString ]
			! !

!MOObject methodsFor: 'persistence' stamp: 'jmck 2/10/2010 23:50'!
delete
	| |
	self description do: [:desc |
		desc isEmbeddedCollection
			ifTrue: [(self readUsing: desc) do: [ :child | child delete ]]].
	super delete.! !

!MOObject methodsFor: 'persistence' stamp: 'jmck 2/6/2010 20:14'!
hasEmbeddedChildren
	"return true if any embedded collection is not empty"
	| collection |
	self description
		do: [:desc | (desc isEmbeddedCollection
					and: [(collection := self readUsing: desc) notEmpty 
						and: [ collection anySatisfy: [ :each | each hasId ]]])
				ifTrue: [^ true]].
	^ false! !

!MOObject methodsFor: 'persistence' stamp: 'jmck 6/17/2009 06:44'!
insert
	| descriptions result value |
	descriptions := self mappedDescription children
		copyWithout: self class descriptionId.
	result := self relation basicQuery: (self relation
		sqlInsert: (descriptions collect: [ :each | each sqlColumnName  ])
		values: (descriptions collect: [ :each | 
			(((value := self readUsing: each) isNil) or: [
				(each isEmbedded or: [ each isEmbeddedCollection]) not ])
			ifTrue: [ value ]
			ifFalse: [
				each isEmbedded 
					ifTrue: [ value id ]
					ifFalse: [ value asIntegerArrayString ]]])) , ';' ,
		(self relation sqlCurrentValue: self class descriptionId sqlColumnName).
	id := result first first.
! !

!MOObject methodsFor: 'persistence' stamp: 'jmck 6/11/2009 17:45'!
loadEmbedded
	self description do: [ :desc |
		desc isEmbedded 
			ifTrue: [ self loadEmbeddedDescription: desc ]
			ifFalse: [
				desc isEmbeddedCollection 
					ifTrue: [ 
						self loadEmbeddedCollectionDescription: desc ]]].
! !

!MOObject methodsFor: 'persistence' stamp: 'jmck 1/19/2010 18:28'!
loadEmbeddedCollectionDescription: aDescription
	"Read the string representation of the integer array returned by postgres, convert it and retrieve the objects replacing the string with the ressurected collection"
	
	| ids embeddedObjects |	
	embeddedObjects := OrderedCollection new.
	ids := self readUsing: aDescription.
	(ids notNil and: [ ids size > 2 ]) 
			ifTrue: [
				(ids asIntegerArray)
					inject: embeddedObjects
					into: [ :collection :i | 
						collection add: (self loadEmbeddedObjectFor: aDescription withId: i); yourself]].
	aDescription accessor write: embeddedObjects to: self ! !

!MOObject methodsFor: 'persistence' stamp: 'jmck 6/13/2009 12:48'!
loadEmbeddedDescription: aDescription
	| embeddedid |
	(embeddedid := self readUsing: aDescription) isNil
		ifFalse: [
			aDescription accessor
				write: (self loadEmbeddedObjectFor: aDescription withId: embeddedid)
				to: self ]! !

!MOObject methodsFor: 'persistence' stamp: 'jmck 6/11/2009 18:35'!
loadEmbeddedObjectFor: aDescription withId: anId
	"This can be overridden if you would rather hit the database for each embedded object
	The current implementation uses uses a class variable to store ALL objects from the DB"
	
	 self subclassResponsibility! !

!MOObject methodsFor: 'persistence' stamp: 'jmck 2/10/2010 06:18'!
mementoClass 
	^MOMemento ! !

MAContainerComponent subclass: #MOContainerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOContainerComponent commentStamp: 'jmck 1/31/2010 16:15' prior: 0!
A MOEmbeddedContainerComponent is the container component that will be created for a MOEmbeddedObject instance. It is this container component that saves the described object to the database upon commit. It is important to note that, for maintaining consistency between the database and the state of the domain objects in the image, that the save occur at the correct point in the executon of the program. Therefore, the save only  occurs automatically upon the commit of a ROOT component (a compnent whose parent is nil). This follows the pattern of Magritte committing of the memento to the obect instance.

Instance Variables
!

!MOContainerComponent methodsFor: 'actions' stamp: 'jmck 2/11/2010 16:58'!
commit
	super commit.
	self model save.! !

!MOContainerComponent methodsFor: 'testing' stamp: 'jmck 2/4/2010 20:58'!
hasChanged
	self withContainersDo: [ :each | each memento hasChanged ifTrue: [ ^ true ] ].
	^self memento hasChanged 
! !
MODatalistObject initialize!
